/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSColorWell;

import dstep.appkit.NSControl;
import dstep.appkit.NSColor;
import dstep.foundation.NSGeometry;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSColorWell : NSControl
{
	mixin (ObjcWrap);

	void deactivate ()
	{
		return invokeObjcSelf!(void, "deactivate");
	}

	void activate (bool exclusive)
	{
		return invokeObjcSelf!(void, "activate:", bool)(exclusive);
	}

	bool isActive ()
	{
		return invokeObjcSelf!(bool, "isActive");
	}

	void drawWellInside (NSRect insideRect)
	{
		return invokeObjcSelf!(void, "drawWellInside:", NSRect)(insideRect);
	}

	bool isBordered ()
	{
		return invokeObjcSelf!(bool, "isBordered");
	}

	void setBordered (bool flag)
	{
		return invokeObjcSelf!(void, "setBordered:", bool)(flag);
	}

	void takeColorFrom (Object sender)
	{
		return invokeObjcSelf!(void, "takeColorFrom:", Object)(sender);
	}

	void setColor (NSColor color)
	{
		return invokeObjcSelf!(void, "setColor:", NSColor)(color);
	}

	NSColor color ()
	{
		return invokeObjcSelf!(NSColor, "color");
	}
}

