/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSController;

import dstep.appkit.NSKeyValueBinding;
import dstep.corefoundation.CoreFoundation;
import dstep.foundation.NSCoder;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSController : NSObject, INSCoding
{
	mixin (ObjcWrap);
	
	this (NSCoder aDecoder)
	{
		super(typeof(this).alloc.initWithCoder(aDecoder).objcObject);
	}
	
	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}
	
	typeof(this) initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(typeof(this), "initWithCoder:", NSCoder)(aDecoder);
	}

	void objectDidBeginEditing (Object editor)
	{
		return invokeObjcSelf!(void, "objectDidBeginEditing:", Object)(editor);
	}

	void objectDidEndEditing (Object editor)
	{
		return invokeObjcSelf!(void, "objectDidEndEditing:", Object)(editor);
	}

	void discardEditing ()
	{
		return invokeObjcSelf!(void, "discardEditing");
	}

	bool commitEditing ()
	{
		return invokeObjcSelf!(bool, "commitEditing");
	}

	void commitEditingWithDelegate (Object delegate_, SEL didCommitSelector, void* contextInfo)
	{
		return invokeObjcSelf!(void, "commitEditingWithDelegate:didCommitSelector:contextInfo:", Object, SEL, void*)(delegate_, didCommitSelector, contextInfo);
	}

	bool isEditing ()
	{
		return invokeObjcSelf!(bool, "isEditing");
	}

}

