/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSMovie;

import dstep.appkit.NSPasteboard;
import dstep.foundation.NSCoder;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTMovie;

class NSMovie : NSObject, INSCoding
{
	mixin (ObjcWrap);
	
	this (NSCoder aDecoder)
	{
		super(typeof(this).alloc.initWithCoder(aDecoder).objcObject);
	}
	
	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}
	
	typeof(this) initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(typeof(this), "initWithCoder:", NSCoder)(aDecoder);
	}
	
	NSMovie initWithMovie (QTMovie movie)
	{
		id result = invokeObjcSelf!(id, "initWithMovie:", QTMovie)(movie);
		return result is this.objcObject ? this : (result !is null ? new NSMovie(result) : null);
	}

	this (QTMovie movie)
	{
		super(NSMovie.alloc.initWithMovie(movie).objcObject);
	}

	QTMovie QTMovie_ ()
	{
		return invokeObjcSelf!(QTMovie, "QTMovie");
	}

}

